/*
	vpd.h

	original code: SASANO Takayoshi
	--- public domain, no warranty.
*/

#include <driver/driver.h>
#include <device/disk.h>
#include <kernel/util.h>
#include <btron/device.h>
#include <inner.h>
#include <tctype.h>
#include <errcode.h>
#include "vpdpart.h"

#ifdef	DEBUG
#define	D(x)	printf x
#else
#define	D(x)	/* */
#endif

#define	BUFSECT		256

typedef	struct _drvwork {
	/* main.c */
	W		drvno;
	W		mbfid;
	FastLock	lock;

	ID		c_devid;
	ID		c_porid;
	ID		c_tskid;

	ID		d_devid;
	ID		d_porid;
	ID		d_tskid;

	/* vpdctl.c */
	W		c_dd;
	VP		c_buf;
	DiskInfo	c_diskinfo;
	TC		c_name[L_DEVNM];
	VPD_PARTINFO	c_partinfo[MAX_PARTINFO + 1];

	/* vpddrv.c */
	Bool		d_openflag[MAX_PARTINFO + 1];
} DrvWork;


#define	CTLTASK_PRI	80
#define	CTLTASK_STKSZ	3072

#define	DRVTASK_PRI	80
#define	DRVTASK_STKSZ	3072

/* main.c */

/* vpdctl.c */
IMPORT	ERR	taskspace_select(DrvWork *wk, DevReq *q);
IMPORT	void	clear_partinfo(DrvWork *wk);
IMPORT	ERR	load_partinfo(DrvWork *wk);
IMPORT	void	ctl_task(UW calptn);

/* vpddrv.c */
IMPORT	void	drv_task(UW calptn);
