/*
	vpddrv.c

	code: SASANO Takayoshi
	--- public domain, no warranty.
*/

#include "vpd.h"

#define	BlockCont(wk, p)	((wk)->c_partinfo[(p)].endblock -	\
			 	 (wk)->c_partinfo[(p)].startblock + 1)
#define	SECTORtoBYTE(wk, s)	((s) * (wk)->c_diskinfo.blocksize)

/* ֹΥå */
LOCAL	W	get_partno(DrvWork *wk, DevReq *q)
{
	W	err, p;

	/* ֹμ */
	p = q->devid - wk->d_devid;

	/* Ƽå */
	if (wk->c_dd < 0) {
		/* ǥХ¸ߤ */
		err = ER_NOMDA;

	} else if (p < 0 || p > MAX_PARTINFO) {
		/* ʶֹ */
		err = ER_NOEXS;

	} else if (wk->c_partinfo[p].systemid <= 0) {
		/* ¸ߤ */
		err = ER_NOMDA;

	} else {
		/* ̵ */
		err = ER_OK;
	}

	return (err < ER_OK) ? err : p;
}

/* ɤ߹ߡᥤ */
LOCAL	ERR	read_block(DrvWork *wk, DevReq *q, DevRsp *r, W partno, W pos, W reqsz)
{
	W	err, rsz;

	/* ɤ߽Ф */
	err = b_rea_dev(wk->c_dd,
			wk->c_partinfo[partno].startblock + q->datano + pos,
			wk->c_buf, reqsz, &rsz, NULL);
	if (err < ER_OK) {
		D(("read_block: b_rea_dev %d\n", err));
		goto fin0;
	}

	/* ɤ߽ФΥå */
	if (reqsz != rsz) {
		D(("read_block: reqsz %d rsz %d\n", reqsz, rsz));
		err = ER_IO;
		goto fin0;
	}

	/* žѥХåեᥤإԡ */
	if (q->memptr != NULL) {
		memcpy(q->memptr + SECTORtoBYTE(wk, pos), wk->c_buf,
		       SECTORtoBYTE(wk, reqsz));
	}

	err = ER_OK;
 fin0:
	return err;
}

/* 񤭹ߡᥤ */
LOCAL	ERR	write_block(DrvWork *wk, DevReq *q, DevRsp *r, W partno, W pos, W reqsz)
{
	W	err, rsz;

	/* ᥤ꤫žѥХåեإԡ */
	if (q->memptr != NULL) {
		memcpy(wk->c_buf, q->memptr + SECTORtoBYTE(wk, pos),
		       SECTORtoBYTE(wk, reqsz));
	} else {
		memset(wk->c_buf, 0, SECTORtoBYTE(wk, reqsz));
	}

	/* 񤭹 */
	err = b_wri_dev(wk->c_dd,
			wk->c_partinfo[partno].startblock + q->datano + pos,
			wk->c_buf, reqsz, &rsz, NULL);
	if (err < ER_OK) {
		D(("write_block: b_wri_dev %d\n", err));
		goto fin0;
	}

	/* 񤭹Υå */
	if (reqsz != rsz) {
		D(("write_block: reqsz %d rsz %d\n", reqsz, rsz));
		err = ER_IO;
		goto fin0;
	}

	err = ER_OK;
 fin0:
	return err;
}

/* ɤ߽ */
LOCAL	ERR	readwrite_sect(DrvWork *wk, DevReq *q, DevRsp *r, W partno)
{
	ERR	err;
	W	pos, remain;

	/* datacnt == 0ʤ񤭹߲ǽʥ֥å֤ */
	pos = q->datacnt ? 0 : BlockCont(wk, partno);

	/* datano/datacnt */
	if ((q->datano + q->datacnt) > BlockCont(wk, partno)) {
		pos = 0;
		err = ER_PAR;
		goto fin0;
	}

	while (pos < q->datacnt) {
		/* žǡ */
		remain = q->datacnt - pos;
		if (remain > BUFSECT) remain = BUFSECT;

		/* ֥åñ̤ɤ߽ */
		err = (q->cmd.cmd == DC_READ) ?
			read_block(wk, q, r, partno, pos, remain) :
			write_block(wk, q, r, partno, pos, remain);
		if (err < ER_OK) {
			D(("readwrite_sect: read/write_block %d\n", err));
			goto fin0;
		}

		/* ǡɤ߽񤭤ǤΤǡpos򹹿 */
		pos += remain;
	}

	err = ER_OK;
 fin0:
	r->datacnt = pos;

	return err;
}

/* DN_DISKEVENT(w) */
LOCAL	ERR	write_dn_diskevent(DrvWork *wk, DevReq *q, DevRsp *r, W partno)
{
	ERR	err;
	W	arglen = sizeof(ID);

	/* ٤񤭹Ǥʤ */
	if (q->datacnt < arglen) {
		err = ER_PAR;
		goto fin0;
	}

	/* ΤоݤȤʤåХåե */
	memcpy(&wk->mbfid, q->memptr, arglen);
	r->datacnt = arglen;

	err = ER_OK;
 fin0:
	return err;
}

/* DN_DISKFORMAT(w) */
LOCAL	ERR	write_dn_diskformat(DrvWork *wk, DevReq *q, DevRsp *r, W partno)
{
	ERR	err;
	DiskFormat	fmt;

	/* 񤭹ߤػߤƤ */
	if (wk->c_diskinfo.protect) {
		err = ER_RONLY;
		goto fin0;
	}

	/* ٤񤭹Ǥʤ */
	if (q->datacnt < sizeof(fmt)) {
		err = ER_PAR;
		goto fin0;
	}

	/* եޥåȷ(DiskFormat)Υå */
	memcpy(&fmt, q->memptr, sizeof(fmt));
	if (fmt != wk->c_diskinfo.format) {
		return ER_PAR;
		goto fin0;
	}

	/* Ŭʥǡ뤿ν */
	q->cmd.cmd = DC_WRITE;
	q->datano  = 0;
	q->datacnt = BlockCont(wk, partno);
	q->memptr  = NULL;

	/* Ƥν */
	err = readwrite_sect(wk, q, r, partno);
	if (err < ER_OK) {
		D(("write_dn_diskformat: readwrite_sect %d\n", err));
	}

	/* ʪǥХξ硢õɬפ */
	if (!partno) {
		clear_partinfo(wk);
	}

	/* 񤭹ϥǤʤDiskFormatΥ(byte) */
	r->datacnt = sizeof(DiskFormat);

 fin0:
	return err;
}

/* DN_DISKINIT(w) */
LOCAL	ERR	write_dn_diskinit(DrvWork *wk, DevReq *q, DevRsp *r, W partno)
{
	ERR	err;
	W	arglen = sizeof(DiskInit);

	/* ٤񤭹Ǥʤ */
	if (q->datacnt < arglen) {
		err = ER_PAR;
		goto fin0;
	}

	/* ʪǥХξDISKINITν񤭹ߤˤꡢǥХκϿ */
	if (!partno && *(DiskInit *)q->memptr == DISKINIT) {
		err = load_partinfo(wk);
		if (err < ER_OK) {
			D(("write_dn_diskinit: load_partinfo %d\n", err));
			goto fin0;
		}
	}

	r->datacnt = arglen;

	err = ER_OK;
 fin0:
	return err;
}	

/* write׵ */
LOCAL	ERR	vpd_write(DrvWork *wk, DevReq *q, DevRsp *r)
{
	W	p;

	p = get_partno(wk, q);

	if (p < ER_OK)	    return p;
	if (q->datacnt < 0) return ER_PAR;
	if (q->datano >= 0) return readwrite_sect(wk, q, r, p);

	switch (q->datano) {
	case	DN_DISKEVENT:	return write_dn_diskevent(wk, q, r, p);
	case	DN_DISKFORMAT:	return write_dn_diskformat(wk, q, r, p);
	case	DN_DISKINIT:	return write_dn_diskinit(wk, q, r, p);
	case	DN_DISKCMD:	return ER_NOSPT;
	default:		return ER_PAR;
	}
}

/* DN_DISKEVENT(r) */
LOCAL	ERR	read_dn_diskevent(DrvWork *wk, DevReq *q, DevRsp *r, W partno)
{
	W	len;

	len = (q->datacnt < sizeof(ID)) ? q->datacnt : sizeof(ID);

	memcpy(q->memptr, &wk->mbfid, len);

	r->datacnt = len;

	return ER_OK;
}

/* DN_DISKINFO(r) */
LOCAL	ERR	read_dn_diskinfo(DrvWork *wk, DevReq *q, DevRsp *r, W partno)
{
	W	len;
	DiskInfo	di;

	len = (q->datacnt < sizeof(DiskInfo)) ? q->datacnt : sizeof(DiskInfo);

	di = wk->c_diskinfo;

	/* Υѥ᡼ */
	di.removable = 0;	/* ˥Բ */
	di.blockcont = BlockCont(wk, partno);

	memcpy(q->memptr, &di, len);

	r->datacnt = len;

	return ER_OK;
}

/* DN_DISKPARTINFO(r) */
LOCAL	ERR	read_dn_diskpartinfo(DrvWork *wk, DevReq *q, DevRsp *r, W partno)
{
	W	err, len;
	DiskPartInfo	dp;

	/* ʪǥХФƤϼ¹ԤǤʤ */
	if (!partno) {
		err = ER_PAR;
		goto fin0;
	}

	len = (q->datacnt < sizeof(dp)) ? q->datacnt : sizeof(dp);

	dp.systemid   = wk->c_partinfo[partno].systemid;
	dp.startblock = wk->c_partinfo[partno].startblock;
	dp.endblock   = wk->c_partinfo[partno].endblock;

	memcpy(q->memptr, &dp, len);

	r->datacnt = len;
	err = ER_OK;
 fin0:
	return err;
}

/* DN_DISKCHSINFO(r) */
LOCAL	ERR	read_dn_diskchsinfo(DrvWork *wk, DevReq *q, DevRsp *r, W partno)
{
	W	err, len;
	DiskCHSInfo	dc;

	len = (q->datacnt < sizeof(dc)) ? q->datacnt : sizeof(dc);

	dc.cylinder = 1;
	dc.head     = 1;
	dc.sector   = BlockCont(wk, 0);	/* ǥΤΥ֥åȤ */

	memcpy(q->memptr, &dc, len);

	r->datacnt = len;
	err = ER_OK;

	return err;
}

/* read׵ */
LOCAL	ERR	vpd_read(DrvWork *wk, DevReq *q, DevRsp *r)
{
	W	p;

	p = get_partno(wk, q);

	if (p < ER_OK)      return p;
	if (q->datacnt < 0) return ER_PAR;
	if (q->datano >= 0) return readwrite_sect(wk, q, r, p);

	switch (q->datano) {
	case	DN_DISKEVENT:	return read_dn_diskevent(wk, q, r, p);
	case	DN_DISKINFO:	return read_dn_diskinfo(wk, q, r, p);
	case	DN_DISKMEMADR:	return ER_NOSPT;
	case	DN_DISKPARTINFO:return read_dn_diskpartinfo(wk, q, r, p);
	case	DN_DISKCHSINFO:	return read_dn_diskchsinfo(wk, q, r, p);
	case	DN_DISKIDINFO:	return ER_NOSPT;
	default:		return ER_PAR;
	}
}

/* ǥХΥ */
LOCAL	ERR	vpd_close(DrvWork *wk, DevReq *q, DevRsp *r)
{
	W	p;

	p = get_partno(wk, q);
	if (p < ER_OK) return p;

	if (!wk->d_openflag[p]) return ER_BUSY;

	wk->d_openflag[p] = False;
	return ER_OK;
}

/* ǥХΥץ */
LOCAL	ERR	vpd_open(DrvWork *wk, DevReq *q, DevRsp *r)
{
	W	p;

	p = get_partno(wk, q);
	if (p < ER_OK)	return p;

	if (wk->d_openflag[p]) return ER_BUSY;
	
	wk->d_openflag[p] = True;
	return ER_OK;
}

/* Ƽ׵Ф */
LOCAL	ERR	drv_request(DrvWork *wk, DevReq *q, DevRsp *r)
{
	switch (q->cmd.cmd) {
		/* ̾׵ */
	case	DC_OPEN:	return vpd_open(wk, q, r);
	case	DC_CLOSE:	
	case	DC_CLOSEALL:	return vpd_close(wk, q, r);

	case	DC_READ:	return vpd_read(wk, q, r);
	case	DC_WRITE:	return vpd_write(wk, q, r);

		/* ü׵ */
	case	DC_ABORT:
	case	DC_SUSPEND:
	case	DC_RESUME:	return ER_OK;		/* ä˲⤷ʤ */

		/* ¾ */
	default:		return ER_NOSPT;	/* ݡϰϳ */
	}
}

/* ɥ饤С */
EXPORT	void	drv_task(UW calptn)
{
	ERR	err;
	RNO	rno;
	W	size;
	T_RTSK	rtsk;
	DevReq	q;
	DevRsp	r;
	DrvWork	*wk;

	/* μ */
	err = ref_tsk(&rtsk, TSK_SELF);
	if (err < ER_OK) {
		D(("drv_task: ref_tsk %d\n", err));
		goto fin0;
	}
	wk = rtsk.exinf;

	/* ٥ȥ롼 */
	while (1) {
		/* ׵Ԥ */
		err = acp_por(&rno, (VP)&q, &size, wk->d_porid, calptn);
		if (err < ER_OK) {
			goto fin1;
		}

		/* ¹ */
		Lock(&wk->lock);

		/* ѥåȥΥå̵ʤ饿ڤؤ */
		err = (size != sizeof(q)) ? ER_PAR : taskspace_select(wk, &q);

		/* ѥѥåȤν׵μ¹ */
		r.devid     = q.devid;
		r.cmd       = q.cmd;
		r.datano    = q.datano;
		r.datacnt   = 0;
		r.error.err = (err < ER_OK) ? err : drv_request(wk, &q, &r);

		/* ǥ֤ؤ */
		err = rpl_rdv(rno, (VP)&r, sizeof(r));
		if (err < ER_OK) {
			D(("drv_task: rpl_rdv %d\n", err));
		}

		/* ¹Դλ */
		Unlock(&wk->lock);
	}

 fin1:
	del_por(wk->d_porid);
 fin0:
	exd_tsk();
}
