/*
	vpdpart.h

	original code: SASANO Takayoshi
	--- public domain, no warranty.
*/

#include <errcode.h>

#define	VPD_SIGNATURE0	0x88730001
#define	MAX_PARTINFO	8

typedef	struct _vpd_header {
	W	entry;		/* $B6h2h?t(B */
	W	offset;		/* $B6h2h%F!<%V%k$X$N%*%U%;%C%H!J@hF,$+$i!K(B */
	W	blocksize;	/* $B%V%m%C%/%5%$%:(B(byte) */
	W	signature;	/* $B%7%0%M%A%c!J%P!<%8%g%sHV9f$r4^$`!K(B */
} VPD_HEADER __attribute__ ((packed));

typedef	struct _vpd_partinfo {
	W	systemid;	/* $B%7%9%F%`(BID */
	W	startblock;	/* $B3+;O%V%m%C%/HV9f(B */
	W	endblock;	/* $B=*N;%V%m%C%/HV9f(B */
	W	reserved;	/* $BM=Ls(B */
} VPD_PARTINFO __attribute__ ((packed));

#if	BIGENDIAN
#define	LittleEndW(x)	((((x) << 24) & 0xff000000) | \
			 (((x) <<  8) & 0x00ff0000) | \
			 (((x) >>  8) & 0x0000ff00) | \
			 (((x) >> 24) & 0x000000ff))
#else
#define	LittleEndW(x)	(x)
#endif

/* $B%(%i!<%3!<%I(B */
#define	ErrorDetail(x)		((x) & 0xffff)
#define	PartInfoError(x)	(ER_OBJ | ErrorDetail(x))

#define	BadSignature		1
#define	BadBlockSize		2
#define	BadOffset		3
#define	BadEntry		4
#define	BadHeader		5
#define	BadStartBlock		6
#define	BadEndBlock		7
#define	BadStartEndBlock	8
#define	BadPartInfo		9

/* vpdctl device$B$NB0@-%G!<%?HV9f(B */
#define	DN_VPDATTACH	-500		/* $B6h2h>pJsEPO?(B */
#define	DN_VPDDETACH	-501		/* $B6h2h>pJs2r=|(B */

/* $B3F<o%5!<%S%94X?t(B */
IMPORT	W		create_header(VP buf, W maxentry, W sectsize);
IMPORT	VPD_HEADER	*check_header(VP buf, W maxentry, W sectsize);
IMPORT	W		export_partinfo(VP buf, VPD_PARTINFO *info,
					W maxentry, W sectsize);
IMPORT	W		import_partinfo(VP buf, VPD_PARTINFO *info,
					W maxentry, W sectsize);
IMPORT	W		check_partinfo(VPD_PARTINFO *info, W maxentry,
				       W start, W end);
#ifdef	DEBUG
IMPORT	void		disp_partinfo(VPD_PARTINFO *info, W entry);
#endif
